# -*- coding: utf-8 -*-

"""
swaggerpetstore

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from swaggerpetstore.api_helper import APIHelper
from swaggerpetstore.models.monetary_value import MonetaryValue


class AccountBalance(object):

    """Implementation of the 'AccountBalance' model.

    This element represents the balance of a merchant account or a managed
    merchant account in a currency registered with the merchant's central
    virtual account.

    Attributes:
        balance (MonetaryValue): Represents a monetary value containing a
            decimal amount value along with a currency code. The currency code
            is a three letter ISO 4217 code. E.g. GBP for British sterling
            pounds.
        balance_timestamp (string): The timestamp of when this balance was
            current at (This is most likely to be within milliseconds of the
            request time). This is a valid ISO 8601 timestamp, such as
            YYYY-MM-DDThh:mm:ss.sss±hh:mm.
        last_movement_timestamp (string): The timestamp of the last money
            movement on the customer’s account.This is a valid ISO 8601
            timestamp, such as YYYY-MM-DDThh:mm:ss.sss±hh:mm.

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "balance": 'balance',
        "balance_timestamp": 'balanceTimestamp',
        "last_movement_timestamp": 'lastMovementTimestamp'
    }

    _optionals = [
        'balance_timestamp',
        'last_movement_timestamp',
    ]

    def __init__(self,
                 balance=None,
                 balance_timestamp=APIHelper.SKIP,
                 last_movement_timestamp=APIHelper.SKIP):
        """Constructor for the AccountBalance class"""

        # Initialize members of the class
        self.balance = balance 
        if balance_timestamp is not APIHelper.SKIP:
            self.balance_timestamp = balance_timestamp 
        if last_movement_timestamp is not APIHelper.SKIP:
            self.last_movement_timestamp = last_movement_timestamp 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """
        if dictionary is None:
            return None

        # Extract variables from the dictionary

        balance = MonetaryValue.from_dictionary(dictionary.get('balance')) if dictionary.get('balance') else None
        balance_timestamp = dictionary.get("balanceTimestamp") if dictionary.get("balanceTimestamp") else APIHelper.SKIP
        last_movement_timestamp = dictionary.get("lastMovementTimestamp") if dictionary.get("lastMovementTimestamp") else APIHelper.SKIP
        # Return an object of this model
        return cls(balance,
                   balance_timestamp,
                   last_movement_timestamp)
