# -*- coding: utf-8 -*-

"""
swaggerpetstore

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from swaggerpetstore.models.field_value import FieldValue


class AdditionalFieldWithValues(object):

    """Implementation of the 'AdditionalFieldWithValues' model.

    Indicates the additional key that can be provided in the payoutDetails
    section of a payout request along with an indication of whether this
    additional payout details entry is mandatory. This will also be followed
    by a series of 'fieldValues' that list the valid codes and descriptions
    that can be submitted as the value of the payoutDetail entry in the payout
    request.

    Attributes:
        key (string): Key for the 'additionalFieldWithValues' data field.
        label (string): Label for the 'additionalFieldWithValues' data field.
        mandatory (bool): Is the 'additionalFieldWithValues' data field?
        field_value (list of FieldValue): Value for the
            'additionalFieldWithValues' data field.

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "key": 'key',
        "label": 'label',
        "mandatory": 'mandatory',
        "field_value": 'fieldValue'
    }

    def __init__(self,
                 key=None,
                 label=None,
                 mandatory=None,
                 field_value=None):
        """Constructor for the AdditionalFieldWithValues class"""

        # Initialize members of the class
        self.key = key 
        self.label = label 
        self.mandatory = mandatory 
        self.field_value = field_value 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """
        if dictionary is None:
            return None

        # Extract variables from the dictionary

        key = dictionary.get("key") if dictionary.get("key") else None
        label = dictionary.get("label") if dictionary.get("label") else None
        mandatory = dictionary.get("mandatory") if "mandatory" in dictionary.keys() else None
        field_value = None
        if dictionary.get('fieldValue') is not None:
            field_value = [FieldValue.from_dictionary(x) for x in dictionary.get('fieldValue')]
        # Return an object of this model
        return cls(key,
                   label,
                   mandatory,
                   field_value)
