# -*- coding: utf-8 -*-

"""
swaggerpetstore

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from swaggerpetstore.api_helper import APIHelper


class BenBankID(object):

    """Implementation of the 'BenBankID' model.

    This group consists of all possible beneficiary bank identifier types. The
    'epBankID' field is a unique identifier for a beneficiary bank account.
    The 'merchantBankID' is an optional merchant specified identifier for the
    beneficiary bank account. The 'epBankID', 'merchantBankID' or both
    'epBankID' and 'merchantBankID' can be supplied. A mapping will be
    performed to retrieve the merchant bank ID from the supplied EP bank ID
    and vice versa. If both the 'epBankID' and 'merchantBankID' are supplied,
    a check will be performed to ensure that the two are mapped. If the two
    provided fields are not mapped, then a validation error code will be
    returned. At least one of the fields must be populated.

    Attributes:
        ep_bank_id (int): The unique ID of a beneficiary bank account.
        merchant_bank_id (string): The merchant specified ID for a beneficiary
            bank account.

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "ep_bank_id": 'epBankID',
        "merchant_bank_id": 'merchantBankID'
    }

    _optionals = [
        'ep_bank_id',
        'merchant_bank_id',
    ]

    def __init__(self,
                 ep_bank_id=APIHelper.SKIP,
                 merchant_bank_id=APIHelper.SKIP):
        """Constructor for the BenBankID class"""

        # Initialize members of the class
        if ep_bank_id is not APIHelper.SKIP:
            self.ep_bank_id = ep_bank_id 
        if merchant_bank_id is not APIHelper.SKIP:
            self.merchant_bank_id = merchant_bank_id 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """
        if dictionary is None:
            return None

        # Extract variables from the dictionary

        ep_bank_id = dictionary.get("epBankID") if dictionary.get("epBankID") else APIHelper.SKIP
        merchant_bank_id = dictionary.get("merchantBankID") if dictionary.get("merchantBankID") else APIHelper.SKIP
        # Return an object of this model
        return cls(ep_bank_id,
                   merchant_bank_id)
