# -*- coding: utf-8 -*-

"""
swaggerpetstore

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from swaggerpetstore.api_helper import APIHelper
from swaggerpetstore.models.beneficiary_bank_account_groups_list import BeneficiaryBankAccountGroupsList
from swaggerpetstore.models.beneficiary_identity_groups_list import BeneficiaryIdentityGroupsList
from swaggerpetstore.models.purpose_of_payment_field_groups_list import PurposeOfPaymentFieldGroupsList


class GetPayoutRequiredDataResponse(object):

    """Implementation of the 'GetPayoutRequiredDataResponse' model.

    All the data required to settle a payment with a given currency into a
    given country.

    Attributes:
        beneficiary_bank_account_field_groups_list
            (BeneficiaryBankAccountGroupsList): This type defines a list of
            bank account data groups. Each group is normally represented as a
            row on the UI.
        beneficiary_identity_field_groups_list
            (BeneficiaryIdentityGroupsList): This type defines a list of
            identity data groups. Each group is normally represented as a
            section of fields on the UI.
        purpose_of_payment_field_groups_list
            (PurposeOfPaymentFieldGroupsList): This group contains all
            configuration information for Purpose of Payment options. The
            'mandatory' attribute indicates whether provision of Purpose of
            Payment data is required for the Payout to be accepted.

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "purpose_of_payment_field_groups_list": 'purposeOfPaymentFieldGroupsList',
        "beneficiary_bank_account_field_groups_list": 'beneficiaryBankAccountFieldGroupsList',
        "beneficiary_identity_field_groups_list": 'beneficiaryIdentityFieldGroupsList'
    }

    _optionals = [
        'beneficiary_bank_account_field_groups_list',
        'beneficiary_identity_field_groups_list',
    ]

    def __init__(self,
                 purpose_of_payment_field_groups_list=None,
                 beneficiary_bank_account_field_groups_list=APIHelper.SKIP,
                 beneficiary_identity_field_groups_list=APIHelper.SKIP):
        """Constructor for the GetPayoutRequiredDataResponse class"""

        # Initialize members of the class
        if beneficiary_bank_account_field_groups_list is not APIHelper.SKIP:
            self.beneficiary_bank_account_field_groups_list = beneficiary_bank_account_field_groups_list 
        if beneficiary_identity_field_groups_list is not APIHelper.SKIP:
            self.beneficiary_identity_field_groups_list = beneficiary_identity_field_groups_list 
        self.purpose_of_payment_field_groups_list = purpose_of_payment_field_groups_list 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """
        if dictionary is None:
            return None

        # Extract variables from the dictionary

        purpose_of_payment_field_groups_list = PurposeOfPaymentFieldGroupsList.from_dictionary(dictionary.get('purposeOfPaymentFieldGroupsList')) if dictionary.get('purposeOfPaymentFieldGroupsList') else None
        beneficiary_bank_account_field_groups_list = BeneficiaryBankAccountGroupsList.from_dictionary(dictionary.get('beneficiaryBankAccountFieldGroupsList')) if 'beneficiaryBankAccountFieldGroupsList' in dictionary.keys() else APIHelper.SKIP
        beneficiary_identity_field_groups_list = BeneficiaryIdentityGroupsList.from_dictionary(dictionary.get('beneficiaryIdentityFieldGroupsList')) if 'beneficiaryIdentityFieldGroupsList' in dictionary.keys() else APIHelper.SKIP
        # Return an object of this model
        return cls(purpose_of_payment_field_groups_list,
                   beneficiary_bank_account_field_groups_list,
                   beneficiary_identity_field_groups_list)
