# -*- coding: utf-8 -*-

"""
swaggerpetstore

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from swaggerpetstore.api_helper import APIHelper
from swaggerpetstore.models.address import Address
from swaggerpetstore.models.legal_entity_registration import LegalEntityRegistration


class LegalEntityIdentity(object):

    """Implementation of the 'LegalEntityIdentity' model.

    The identity of a legal entity. The 'legalEntityName' is mandatory. You
    must supply one of 'legalEntityRegistration' or 'address'.

    Attributes:
        legal_entity_name (string): The name component of the legal entity.
            The length of this field is limited to 1024 bytes. 1024 bytes can
            hold 1024 normal English characters.
        legal_entity_registration (LegalEntityRegistration): This group
            consists of a legal entity registration number type and the
            country that the legal entity is registered in. Legal Entity
            Registration Number is mandatory, Legal Entity Registration
            Country is mandatory and Legal Entity Registration Province is
            optional.
        address (Address): Represents an address. Mandatory attributes are
            'addressLine1', 'city' and 'country'. All other attributes are
            optional.

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "legal_entity_name": 'legalEntityName',
        "legal_entity_registration": 'legalEntityRegistration',
        "address": 'address'
    }

    _optionals = [
        'legal_entity_registration',
        'address',
    ]

    def __init__(self,
                 legal_entity_name=None,
                 legal_entity_registration=APIHelper.SKIP,
                 address=APIHelper.SKIP):
        """Constructor for the LegalEntityIdentity class"""

        # Initialize members of the class
        self.legal_entity_name = legal_entity_name 
        if legal_entity_registration is not APIHelper.SKIP:
            self.legal_entity_registration = legal_entity_registration 
        if address is not APIHelper.SKIP:
            self.address = address 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """
        if dictionary is None:
            return None

        # Extract variables from the dictionary

        legal_entity_name = dictionary.get("legalEntityName") if dictionary.get("legalEntityName") else None
        legal_entity_registration = LegalEntityRegistration.from_dictionary(dictionary.get('legalEntityRegistration')) if 'legalEntityRegistration' in dictionary.keys() else APIHelper.SKIP
        address = Address.from_dictionary(dictionary.get('address')) if 'address' in dictionary.keys() else APIHelper.SKIP
        # Return an object of this model
        return cls(legal_entity_name,
                   legal_entity_registration,
                   address)
