# -*- coding: utf-8 -*-

"""
swaggerpetstore

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from swaggerpetstore.api_helper import APIHelper


class LegalEntityRegistration(object):

    """Implementation of the 'LegalEntityRegistration' model.

    This group consists of a legal entity registration number type and the
    country that the legal entity is registered in. Legal Entity Registration
    Number is mandatory, Legal Entity Registration Country is mandatory and
    Legal Entity Registration Province is optional.

    Attributes:
        legal_entity_registration_country (string): Valid supported ISO 3166
            2-character country code. This represents Registration Country of
            the Legal Entity.
        legal_entity_registration_number (string): The registration number
            component of the legal entity. The length of this field is limited
            to 254 bytes. 254 bytes can hold 254 normal English characters.
            This value will be truncated if it is too long.
        legal_entity_registration_province (string): Optional province of the
            legal entity's address.

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "legal_entity_registration_country": 'legalEntityRegistrationCountry',
        "legal_entity_registration_number": 'legalEntityRegistrationNumber',
        "legal_entity_registration_province": 'legalEntityRegistrationProvince'
    }

    _optionals = [
        'legal_entity_registration_province',
    ]

    def __init__(self,
                 legal_entity_registration_country=None,
                 legal_entity_registration_number=None,
                 legal_entity_registration_province=APIHelper.SKIP):
        """Constructor for the LegalEntityRegistration class"""

        # Initialize members of the class
        self.legal_entity_registration_country = legal_entity_registration_country 
        self.legal_entity_registration_number = legal_entity_registration_number 
        if legal_entity_registration_province is not APIHelper.SKIP:
            self.legal_entity_registration_province = legal_entity_registration_province 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """
        if dictionary is None:
            return None

        # Extract variables from the dictionary

        legal_entity_registration_country = dictionary.get("legalEntityRegistrationCountry") if dictionary.get("legalEntityRegistrationCountry") else None
        legal_entity_registration_number = dictionary.get("legalEntityRegistrationNumber") if dictionary.get("legalEntityRegistrationNumber") else None
        legal_entity_registration_province = dictionary.get("legalEntityRegistrationProvince") if dictionary.get("legalEntityRegistrationProvince") else APIHelper.SKIP
        # Return an object of this model
        return cls(legal_entity_registration_country,
                   legal_entity_registration_number,
                   legal_entity_registration_province)
