# -*- coding: utf-8 -*-

"""
swaggerpetstore

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from swaggerpetstore.api_helper import APIHelper


class QuotesBulkRequest(object):

    """Implementation of the 'QuotesBulkRequest' model.

    This request is used to retrieve cross rates between the required sell
    currencies and buy currencies.

    Attributes:
        sell_currency (string): Valid supported ISO 4217 3-character currency
            code. Sell Currency is the currency the merchant wishes to be
            debited in.
        buy_currency (string): Valid supported ISO 4217 3-character currency
            code. Buy Currency is the currency the merchant wishes to buy or
            convert the sell currency into. For a Payment Request this must be
            one of the currencies registered for a Beneficiary Bank Account,
            otherwise the Earthport system will throw a validation error.
        buy_country (string): Valid supported ISO 3166 2-character country
            code. Represents Buy Country for which FxRate was found.
        service_level (ServiceLevelEnum): Supported service levels for a
            payout request (standard or express).

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "sell_currency": 'sellCurrency',
        "buy_currency": 'buyCurrency',
        "buy_country": 'buyCountry',
        "service_level": 'serviceLevel'
    }

    _optionals = [
        'buy_currency',
        'buy_country',
        'service_level',
    ]

    def __init__(self,
                 sell_currency=None,
                 buy_currency=APIHelper.SKIP,
                 buy_country=APIHelper.SKIP,
                 service_level=APIHelper.SKIP):
        """Constructor for the QuotesBulkRequest class"""

        # Initialize members of the class
        self.sell_currency = sell_currency 
        if buy_currency is not APIHelper.SKIP:
            self.buy_currency = buy_currency 
        if buy_country is not APIHelper.SKIP:
            self.buy_country = buy_country 
        if service_level is not APIHelper.SKIP:
            self.service_level = service_level 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """
        if dictionary is None:
            return None

        # Extract variables from the dictionary

        sell_currency = dictionary.get("sellCurrency") if dictionary.get("sellCurrency") else None
        buy_currency = dictionary.get("buyCurrency") if dictionary.get("buyCurrency") else APIHelper.SKIP
        buy_country = dictionary.get("buyCountry") if dictionary.get("buyCountry") else APIHelper.SKIP
        service_level = dictionary.get("serviceLevel") if dictionary.get("serviceLevel") else APIHelper.SKIP
        # Return an object of this model
        return cls(sell_currency,
                   buy_currency,
                   buy_country,
                   service_level)
