# -*- coding: utf-8 -*-

"""
swaggerpetstore

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from swaggerpetstore.api_helper import APIHelper
from swaggerpetstore.models.monetary_value import MonetaryValue


class QuotesRequest(object):

    """Implementation of the 'QuotesRequest' model.

    This request is used to retrieve a cross rate between the required sell
    currency and buy currency.

    Attributes:
        sell_amount (MonetaryValue): Represents a monetary value containing a
            decimal amount value along with a currency code. The currency code
            is a three letter ISO 4217 code. E.g. GBP for British sterling
            pounds.
        buy_currency (string): Valid supported ISO 4217 3-character currency
            code. Buy Currency is the currency the merchant wishes to buy or
            convert the sell currency into. For a Payment Request this must be
            one of the currencies registered for a Beneficiary Bank Account or
            Beneficiary Wallet, otherwise the Earthport system will throw a
            validation error.
        buy_amount (MonetaryValue): Represents a monetary value containing a
            decimal amount value along with a currency code. The currency code
            is a three letter ISO 4217 code. E.g. GBP for British sterling
            pounds.
        sell_currency (string): Valid supported ISO 4217 3-character currency
            code. Sell Currency is the currency the merchant wishes to be
            debited in, in order to buy the Buy Amount.
        service_level (ServiceLevelEnum): Supported service levels for a
            payout request (standard or express).

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "sell_amount": 'sellAmount',
        "buy_currency": 'buyCurrency',
        "buy_amount": 'buyAmount',
        "sell_currency": 'sellCurrency',
        "service_level": 'serviceLevel'
    }

    _optionals = [
        'sell_amount',
        'buy_currency',
        'buy_amount',
        'sell_currency',
        'service_level',
    ]

    def __init__(self,
                 sell_amount=APIHelper.SKIP,
                 buy_currency=APIHelper.SKIP,
                 buy_amount=APIHelper.SKIP,
                 sell_currency=APIHelper.SKIP,
                 service_level=APIHelper.SKIP):
        """Constructor for the QuotesRequest class"""

        # Initialize members of the class
        if sell_amount is not APIHelper.SKIP:
            self.sell_amount = sell_amount 
        if buy_currency is not APIHelper.SKIP:
            self.buy_currency = buy_currency 
        if buy_amount is not APIHelper.SKIP:
            self.buy_amount = buy_amount 
        if sell_currency is not APIHelper.SKIP:
            self.sell_currency = sell_currency 
        if service_level is not APIHelper.SKIP:
            self.service_level = service_level 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """
        if dictionary is None:
            return None

        # Extract variables from the dictionary

        sell_amount = MonetaryValue.from_dictionary(dictionary.get('sellAmount')) if 'sellAmount' in dictionary.keys() else APIHelper.SKIP
        buy_currency = dictionary.get("buyCurrency") if dictionary.get("buyCurrency") else APIHelper.SKIP
        buy_amount = MonetaryValue.from_dictionary(dictionary.get('buyAmount')) if 'buyAmount' in dictionary.keys() else APIHelper.SKIP
        sell_currency = dictionary.get("sellCurrency") if dictionary.get("sellCurrency") else APIHelper.SKIP
        service_level = dictionary.get("serviceLevel") if dictionary.get("serviceLevel") else APIHelper.SKIP
        # Return an object of this model
        return cls(sell_amount,
                   buy_currency,
                   buy_amount,
                   sell_currency,
                   service_level)
