# -*- coding: utf-8 -*-

"""
swaggerpetstore

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from swaggerpetstore.api_helper import APIHelper


class TransactionsCancelResponse(object):

    """Implementation of the 'TransactionsCancelResponse' model.

    This represents the response of a cancellation request for a transaction
    (payout instruction).

    Attributes:
        status (string): Specifies the status of the associated transaction
            for the cancellation request.
        status_description (string): Description associated with the
            cancellation status.
        timestamp (string): A valid ISO 8601 timestamp, such as
            YYYY-MM-DDThh:mm:ss.sss±hh:mm. This represents the cancellation
            request timestamp.

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "status": 'status',
        "status_description": 'statusDescription',
        "timestamp": 'timestamp'
    }

    _optionals = [
        'status',
        'status_description',
        'timestamp',
    ]

    def __init__(self,
                 status=APIHelper.SKIP,
                 status_description=APIHelper.SKIP,
                 timestamp=APIHelper.SKIP):
        """Constructor for the TransactionsCancelResponse class"""

        # Initialize members of the class
        if status is not APIHelper.SKIP:
            self.status = status 
        if status_description is not APIHelper.SKIP:
            self.status_description = status_description 
        if timestamp is not APIHelper.SKIP:
            self.timestamp = timestamp 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """
        if dictionary is None:
            return None

        # Extract variables from the dictionary

        status = dictionary.get("status") if dictionary.get("status") else APIHelper.SKIP
        status_description = dictionary.get("statusDescription") if dictionary.get("statusDescription") else APIHelper.SKIP
        timestamp = dictionary.get("timestamp") if dictionary.get("timestamp") else APIHelper.SKIP
        # Return an object of this model
        return cls(status,
                   status_description,
                   timestamp)
